import fs from 'fs';
import webpack from 'webpack';
import path from 'path';
import HtmlWebpackPlugin from 'html-webpack-plugin';
import { getLocalNetwork } from './tools/network';

// Define the network address to be used
const localAddress = getLocalNetwork() || 'localhost';

// Define the desired environment variables
const EnvironmentVariables = new webpack.EnvironmentPlugin({
  NODE_ENV: 'development',  // use 'development' unless process.env.NODE_ENV is defined
  DEBUG: true, // use true unless process.env.DEBUG is defined
  __DEV__: true // use true unless process.env.__DEV__ is defined
});

// Remove babel modules from the defined presets (required to let webpack handle module management)
const babelConfigStr = fs.readFileSync(`${__dirname}/.babelrc`, 'utf8');
const babelConfig = JSON.parse(babelConfigStr);
const jsPresets = ['env', 'es2015', 'es2016', 'es2017', 'latest'];
let babelPresets = babelConfig.presets;
babelPresets = babelPresets.map(preset => {
  if (jsPresets.includes(preset)) {
    return [preset, { modules: false }];
  }
  return preset;
});

export default {
  // Development Tools source code strategy
  // NOTE: https://webpack.github.io/docs/build-performance.html#sourcemaps and
  //       https://webpack.github.io/docs/configuration.html#devtool
  devtool: 'cheap-module-eval-source-map',

  // application entry points
  entry: [
    // Include babel polyfill for browser compatibility with the JavaScript new specs
    'babel-polyfill',

    // Add triggers to react hot load
    'react-hot-loader/patch',

    // Connects to the server to receive notifications when the bundle rebuilds
    // and then updates your client bundle accordingly.
    'webpack-hot-middleware/client?reload=true',

    // Starting point of our js application
    './src/index'
  ],

  // Necessary per https://webpack.github.io/docs/testing.html#compile-and-test
  target: 'web',

  // Application output configuration
  // NOTE: when served using webpack-dev-middleware no physical file will be
  //        outputed with this confiration
  output: {
    // Output folder path
    path: path.join(__dirname, 'src'),

    // Use absolute paths to avoid the way that URLs are resolved by Chrome when they're parsed
    // from a dynamically loaded CSS blob. Note: Only necessary in Dev.
    publicPath: 'http://' + localAddress + ':5515/',

    // Bundled js file
    filename: '[name].bundle.js',

    // Bundled js chunks
    chunkFilename: '[name].chunk.js'
  },

  // Plugins used to enhance the source encoding
  plugins: [
    // Expose environment variables
    EnvironmentVariables,

    // Enable HMR (Hot Module Replacement)
    new webpack.HotModuleReplacementPlugin(),

    // Prints more readable module names in the browser console on HMR updates
    new webpack.NamedModulesPlugin(),

    // Do not emit compiled assets that include errors
    new webpack.NoEmitOnErrorsPlugin(),

    // Creates a HTML file that includes references to bundled assets generated by webpack (e.g: JS, CSS, ...)
    new HtmlWebpackPlugin({
      // Relative path to the template file
      template: 'public/index.html',

      // Minification options for the generated template file
      minify: {
        removeComments: true,
        collapseWhitespace: true
      },

      // Inject all assets into the given template at the bottom of the body block
      inject: true
    })
  ],

  // Webpack processing rules
  module: {
    rules: [
      { // scripts
        test: /\.js$/,
        include: path.join(__dirname, 'src'),
        exclude: path.join(__dirname, 'tools'),
        use: [
          {
            loader: 'babel-loader',
            options: {
              presets: babelPresets
            }
          }
        ]
      },
      { // fonts - EOT format
        test: /\.eot(\?v=\d+.\d+.\d+)?$/,
        use: [
          {
            loader: 'file-loader',
            options: {
              debug: true,
              name: 'fonts/[name].[ext]'
            }
          }
        ]
      },
      { // fonts - WOOF format
        test: /\.woff(2)?(\?v=[0-9]\.[0-9]\.[0-9])?$/,
        use: [
          {
            loader: 'url-loader',
            options: {
              debug: true,
              limit: 10000,
              mimetype: 'application/font-woff',
              name: 'fonts/[name].[ext]'
            }
          }
        ]
      },
      { // fonts - TTF format
        test: /\.ttf(\?v=\d+.\d+.\d+)?$/,
        use: [
          {
            loader: 'file-loader',
            options: {
              debug: true,
              limit: 10000,
              mimetype: 'application/octet-stream',
              name: 'fonts/[name].[ext]'
            }
          }
        ]
      },
      { // fonts - SVG format
        test: /\.svg(\?v=\d+.\d+.\d+)?$/,
        include: path.join(__dirname, 'src', 'assets', 'fonts'),
        use: [
          {
            loader: 'file-loader',
            options: {
              debug: true,
              limit: 10000,
              mimetype: 'image/svg+xml',
              name: 'fonts/[name].[ext]'
            }
          }
        ]
      },
      { // images
        test: /\.(jpe?g|png|gif|svg)$/i,
        include: path.join(__dirname, 'src'),
        exclude: path.join(__dirname, 'src', 'assets', 'fonts'),
        use: [
          {
            loader: 'file-loader',
            options: {
              debug: true,
              name: 'images/[name].[ext]'
            }
          }
        ]
      },
      { // ico files - usually just for the favicon.ico
        test: /\.ico$/,
        use: [
          {
            loader: 'file-loader',
            options: {
              debug: true,
              name: '[name].[ext]'
            }
          }
        ]
      },
      { // css files
        test: /(\.css|\.scss)$/,
        use: [
          {
            loader: 'style-loader',
            options: {
              debug: true
            }
          },
          {
            loader: 'css-loader',
            options: {
              debug: true,
              sourceMap: true
            }
          },
          {
            loader: 'sass-loader',
            options: {
              debug: true,
              sourceMap: true,
              includePaths: [
                path.resolve(__dirname, 'node_modules', 'foundation-sites', 'scss')
              ]
            }
          }
        ]
      }
    ]
  }
};
